## bind9 9.18.18

=== debian/changelog ===
bind9 (1:9.18.18-0ubuntu2.1) mantic-security; urgency=medium

  * SECURITY UPDATE: Multiple security issues
    - debian/patches/0001-CVE-2023-4408.patch: Parsing large DNS messages
      may cause excessive CPU load.
    - debian/patches/0002-CVE-2023-5517.patch: Querying RFC 1918 reverse
      zones may cause an assertion failure when nxdomain-redirect is
      enabled.
    - debian/patches/0003-CVE-2023-5679.patch: Enabling both DNS64 and
      serve-stale may cause an assertion failure during recursive
      resolution.
    - debian/patches/0004-CVE-2023-50387-CVE-2023-50868.patch: Extreme CPU
      consumption in DNSSEC validator and Preparing an NSEC3 closest
      encloser proof can exhaust CPU resources.
    - CVE-2023-4408
    - CVE-2023-5517
    - CVE-2023-5679
    - CVE-2023-50387
    - CVE-2023-50868

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 12 Feb 2024 14:29:56 -0500

bind9 (1:9.18.18-0ubuntu2) mantic; urgency=medium

  * SECURITY UPDATE: DoS via recusive packet parsing
    - debian/patches/CVE-2023-3341.patch: add a max depth check to
      lib/isc/include/isc/result.h, lib/isc/result.c, lib/isccc/cc.c.
    - CVE-2023-3341
  * SECURITY UPDATE: Dos via DNS-over-TLS queries
    - debian/patches/CVE-2023-4236.patch: check return code in
      lib/isc/netmgr/tlsdns.c.
    - CVE-2023-4236

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 20 Sep 2023 12:45:21 -0400

bind9 (1:9.18.18-0ubuntu1) mantic; urgency=medium

  * New upstream release 9.18.18 (LP: #2034367)
    - Updates:
      + Mark a primary server as temporarily unreachable when a TCP connection
        response to an SOA query times out, matching behavior of a refused TCP
        connection.
      + Mark dialup and heartbeat-interval options as deprecated.
      + Retry DNS queries without an EDNS COOKIE when the first response is
        FORMERR with the EDNS COOKIE that was sent originally.
      + Use NS records for the relaxed QNAME minimization mode to reduce the
        number of queries from named.
    - Bug Fixes:
      + Fix assertion failure from processing already-queued queries while
        server is being reconfigured or cache is being flushed.
      + Fix failure to load zones containing resource records with a TTL value
        larger than 86400 seconds when dnssec-policy is set to insecure.
      + Fix the ability to read HMAC-MD5 key files (LP: #2015176).
      + Fix stability issues with the catalog zone implementation.
    - See https://bind9.readthedocs.io/en/v9.18.18/notes.html for additional
      information.

 -- Lena Voytek <lena.voytek@canonical.com>  Tue, 05 Sep 2023 13:20:06 -0700

bind9 (1:9.18.16-1ubuntu4) mantic; urgency=medium

  * d/t/dyndb-ldap: allow writing to the dns tree (LP: #2034250)

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 05 Sep 2023 10:20:27 -0300

bind9 (1:9.18.16-1ubuntu3) mantic; urgency=medium

  * d/t/control: exclude the i386 architecture for the dyndb-ldap test,
    since bind9-dyndb-ldap is not available there on Ubuntu
  * d/t/dyndb-ldap: fix for the ldap bind9 dn entry

 -- Andreas Hasenack <andreas@canonical.com>  Wed, 30 Aug 2023 10:14:04 -0300

=== debian/control ===
Source: bind9
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DNS Team <team+dns@tracker.debian.org>
Uploaders: Ondřej Surý <ondrej@debian.org>,
           Bernhard Schmidt <berni@debian.org>
Build-Depends: bison,
               debhelper-compat (= 12),
               dh-apparmor,
               dh-apport,
               dh-exec,
               libcap2-dev [linux-any],
               libcmocka-dev,
               libdb-dev,
               libedit-dev,
               libidn2-dev,
               libjson-c-dev,
               libkrb5-dev,
               liblmdb-dev,
               libltdl-dev,
               libmaxminddb-dev (>= 1.3.0),
               libnghttp2-dev,
               libssl-dev,
               libsystemd-dev [linux-any],
               libtool,
               libuv1-dev (>= 1.40.0),
               libxml2-dev,
               pkg-config,
               python3,
               zlib1g-dev
Build-Depends-Indep: fonts-freefont-otf,
                     latexmk,
                     python3-sphinx,
                     python3-sphinx-rtd-theme,
                     texlive-fonts-extra,
                     texlive-latex-recommended,
                     texlive-xetex,
                     xindy
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/dns-team/bind9
Vcs-Git: https://salsa.debian.org/dns-team/bind9.git -b debian/9.18
Homepage: https://www.isc.org/downloads/bind/

Package: bind9
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         bind9-libs (= ${binary:Version}),
         bind9-utils (= ${binary:Version}),
         debconf | debconf-2.0,
         dns-root-data,
         iproute2,
         netbase,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: bind-doc,
          dnsutils,
          resolvconf,
          ufw
Breaks: bind (<< 1:9.13.6~)
Replaces: bind (<< 1:9.13.6~)
Description: Internet Domain Name Server
 The Berkeley Internet Name Domain (BIND 9) implements an Internet domain
 name server.  BIND 9 is the most widely-used name server software on the
 Internet, and is supported by the Internet Software Consortium, www.isc.org.
 .
 This package provides the server and related configuration files.

Package: bind9utils
Architecture: all
Depends: bind9-utils,
         ${misc:Depends}
Priority: optional
Section: oldlibs
Description: Transitional package for bind9-utils
 This is a transitional package. It can safely be removed.

Package: bind9-utils
Architecture: any
Depends: bind9-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: bind-utils (<< 1:9.13.6~),
        bind9utils (<< 1:9.12.0~),
        freeipa
Replaces: bind-utils (<< 1:9.13.6~),
          bind9utils (<< 1:9.12.0~)
Provides: bind9utils
Description: Utilities for BIND 9
 This package provides various utilities that are useful for maintaining a
 working BIND 9 installation.

Package: bind9-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Breaks: bind-doc (<< 1:9.13.6~)
Replaces: bind-doc (<< 1:9.13.6~)
Description: Documentation for BIND 9
 This package provides various documents that are useful for maintaining a
 working BIND 9 installation.

Package: bind9-host
Priority: standard
Architecture: any
Depends: bind9-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: host
Breaks: bind-host (<< 1:9.13.6~)
Replaces: bind-host (<< 1:9.13.6~)
Description: DNS Lookup Utility
 This package provides the 'host' DNS lookup utility in the form that
 is bundled with the BIND 9 sources.

Package: bind9-libs
Section: libs
Priority: standard
Architecture: any
Multi-Arch: same
Depends: libuv1 (>= 1.40.0),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: bind-libs (<< 1:9.13.6~)
Replaces: bind-libs (<< 1:9.13.6~)
Description: Shared Libraries used by BIND 9
 The Berkeley Internet Name Domain (BIND 9) implements an Internet domain
 name server.  BIND 9 is the most widely-used name server software on the
 Internet, and is supported by the Internet Software Consortium, www.isc.org.
 .
 This package contains a bundle of shared libraries used by BIND 9.

Package: bind9-dev
Section: devel
Priority: optional
Architecture: any
Multi-Arch: same
Depends: bind9-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libbind-dev (<< 1:9.16.0~)
Replaces: libbind-dev (<< 1:9.16.0~)
Description: Static Libraries and Headers used by BIND 9
 The Berkeley Internet Name Domain (BIND 9) implements an Internet domain
 name server.  BIND 9 is the most widely-used name server software on the
 Internet, and is supported by the Internet Software Consortium, www.isc.org.
 .
 This package contains a bundle of static libraries and header files used by
 BIND 9.
 .
 Please be aware that the BIND 9 libraries are considered private by upstream
 developers and the API and ABI might break at any time.

Package: dnsutils
Architecture: all
Depends: bind9-dnsutils,
         ${misc:Depends}
Priority: optional
Section: oldlibs
Description: Transitional package for bind9-dnsutils
 This is a transitional package. It can safely be removed.

Package: bind9-dnsutils
Priority: standard
Architecture: any
Depends: bind9-host | host,
         bind9-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: bind-dnsutils (<< 1:9.13.6~),
        dnsutils (<< 1:9.13.6~)
Conflicts: bind-dnsutils (<< 1:9.13.6~),
           dnsutils (<< 1:9.13.6~)
Provides: dnsutils
Description: Clients provided with BIND 9
 The Berkeley Internet Name Domain (BIND 9) implements an Internet domain
 name server.  BIND 9 is the most widely-used name server software on the
 Internet, and is supported by the Internet Software Consortium, www.isc.org.
 .
 This package delivers various client programs related to DNS that are
 derived from the BIND 9 source tree.
 .
  - dig - query the DNS in various ways
  - nslookup - the older way to do it
  - nsupdate - perform dynamic updates (See RFC2136)

## bind9 9.18.19

=== debian/changelog ===
bind9 (1:9.18.19-1~deb12u1) bookworm-security; urgency=high

  * New upstream version 9.18.19
   - CVE-2023-3341: A stack exhaustion flaw in control channel code may
     cause named to terminate unexpectedly
   - CVE-2023-4236: named may terminate unexpectedly under high
     DNS-over-TLS query load

 -- Ondřej Surý <ondrej@debian.org>  Thu, 21 Sep 2023 19:33:58 +0200

bind9 (1:9.18.16-1~deb12u1) bookworm-security; urgency=high

  * New upstream version 9.18.16
   - CVE-2023-2828: The overmem cleaning process has been improved,
     to prevent the cache from significantly exceeding the configured
     max-cache-size limit.
   - CVE-2023-2911: A query that prioritizes stale data over lookup
     triggers a fetch to refresh the stale data in cache. If the fetch
     is aborted for exceeding the recursion quota, it was possible for
     named to enter an infinite callback loop and crash due to stack
     overflow. This has been fixed.

 -- Ondřej Surý <ondrej@debian.org>  Wed, 21 Jun 2023 20:48:44 +0200

## bind9 9.18.24

=== contrib/dlz/example/Makefile ===
# Copyright (C) Internet Systems Consortium, Inc. ("ISC")
#
# SPDX-License-Identifier: MPL-2.0
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0.  If a copy of the MPL was not distributed with this
# file, you can obtain one at https://mozilla.org/MPL/2.0/.
#
# See the COPYRIGHT file distributed with this work for additional
# information regarding copyright ownership.

# for building the dlz_example driver we don't use
# the bind9 build structure as the aim is to provide an
# example that is separable from the bind9 source tree

# this means this Makefile is not portable, so the testsuite
# skips this test on platforms where it doesn't build

CFLAGS += -Wall -fPIC -g

all: dlz_example.so

dlz_example.so: dlz_example.o
	$(CC) $(CFLAGS) -shared -o dlz_example.so dlz_example.o

clean:
	rm -f dlz_example.o dlz_example.so

=== contrib/dlz/modules/ldap/Makefile ===
# Copyright Internet Systems Consortium, Inc. ("ISC")
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, you can obtain one at https://mozilla.org/MPL/2.0/.

# Copyright (C) Stichting NLnet, Netherlands, stichting@nlnet.nl.
#
# The development of Dynamically Loadable Zones (DLZ) for Bind 9 was
# conceived and contributed by Rob Butler.
#
# SPDX-License-Identifier: ISC and MPL-2.0
#
# Permission to use, copy, modify, and distribute this software for any purpose
# with or without fee is hereby granted, provided that the above copyright
# notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND STICHTING NLNET DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL STICHTING NLNET BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

prefix = /usr
libdir = $(prefix)/lib/bind9

CFLAGS += -fPIC -g -I../include
LDAP_LIBS=-lldap

all: dlz_ldap_dynamic.so

dlz_dbi.o: ../common/dlz_dbi.c
	$(CC) $(CFLAGS) -c ../common/dlz_dbi.c

dlz_ldap_dynamic.so: dlz_ldap_dynamic.c dlz_dbi.o
	$(CC) $(CFLAGS) -shared -o dlz_ldap_dynamic.so \
		dlz_ldap_dynamic.c dlz_dbi.o $(LDAP_LIBS)

clean:
	rm -f dlz_ldap_dynamic.so *.o

install: dlz_ldap_dynamic.so
	mkdir -p $(DESTDIR)$(libdir)
	install dlz_ldap_dynamic.so $(DESTDIR)$(libdir)

=== debian/changelog ===
bind9 (1:9.18.24-0ubuntu5) noble; urgency=high

  * No change rebuild against libssl3t64, libuv1t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 16:37:41 +0200

bind9 (1:9.18.24-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:04:23 +0000

bind9 (1:9.18.24-0ubuntu3) noble; urgency=medium

  * bind9-libs: Hard-code libuv1t64 instead of libuv1.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Mar 2024 12:35:21 +0100

bind9 (1:9.18.24-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 17:27:42 +0000

bind9 (1:9.18.24-0ubuntu1) noble; urgency=medium

  * Updated to 9.18.21 to fix security issues.
    - Security Fixes:
      + Validating DNS messages containing a lot of DNSSEC signatures could
        cause excessive CPU load, leading to a denial-of-service condition.
        This has been fixed. (CVE-2023-50387)
      + Preparing an NSEC3 closest encloser proof could cause excessive CPU
        load, leading to a denial-of-service condition. This has been
        fixed. (CVE-2023-50868)
      + Parsing DNS messages with many different names could cause
        excessive CPU load. This has been fixed. (CVE-2023-4408)
      + Specific queries could cause named to crash with an assertion
        failure when nxdomain-redirect was enabled. This has been fixed.
        (CVE-2023-5517)
      + A bad interaction between DNS64 and serve-stale could cause named
        to crash with an assertion failure, when both of these features
        were enabled. This has been fixed. (CVE-2023-5679)
      + Under certain circumstances, the DNS-over-TLS client code
        incorrectly attempted to process more than one DNS message at a
        time, which could cause named to crash with an assertion failure.
        This has been fixed.
    - Bug Fixes:
      + The counters exported via the statistics channel were changed back
        to 64-bit signed values; they were being inadvertently truncated to
        unsigned 32-bit values since BIND 9.15.0.
    - See https://bind9.readthedocs.io/en/v9.18.24/notes.html for
      additional information

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 14 Feb 2024 14:31:05 -0500

bind9 (1:9.18.21-0ubuntu1) noble; urgency=medium

  * New upstream release 9.18.21 (LP: #2040359)
    - Updates:
      + Update IP addresses for B.ROOT-SERVERS.NET to 170.247.170.2 and
        2801:1b8:10::b.
      + Honor nsupdate -v option when server command specified by sending both
        the UPDATE request and the initial query over TCP.
      + Mark cookie-algorithm aes as deprecated, use SipHash-2-4, instead.
      + Mark resolver-nonbackoff-tries and resolver-retry-interval as
        deprecated.
      + Mark dnssec-must-be-secure as deprecated.
    - Bug Fixes:
      + Do not schedule unsigned versions of inline-signed zones containing
        DNSSEC records for resigning.
      + Take local authoritative data into account when looking up stale cache
        data.
      + Fix use of named -X and lock-file at the same time.
      + Fix improper lock-file removal.
      + Fix bound checking in Content-Length header in the statistics channel.
      + Fix memory leaks from not clearing the OpenSSL error stack.
      + Fix SERVFAIL responses from introduction of krb5-subdomain-self-rhs and
        ms-subdomain-self-rhs update policies.
      + Fix stale-refresh-time feature being disabled by cache flush.
      + Fix DNS message corruption from partial writes.
    - See https://bind9.readthedocs.io/en/v9.18.21/notes.html for additional
      information
  * d/p/CVE-2023-3341.patch, d/p/CVE-2023-4236.patch: Remove - fixed by
    upstream in version 9.18.19
  * d/p/always-use-standard-library-stdatomic.patch: Maintain use of the
    standard library stdatomic.h

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 25 Jan 2024 08:37:15 -0700

=== debian/tests/control ===
Tests: simpletest
Restrictions: isolation-container, needs-internet, needs-root
Depends: bind9,
         bind9-dnsutils

Tests: validation
Restrictions: isolation-container, needs-internet, needs-root, flaky
Depends: bind9,
         bind9-dnsutils

Tests: zonetest
Restrictions: isolation-container, needs-root
Depends: bind9,
         bind9-dnsutils,
         bind9-utils

Tests: dyndb-ldap
Restrictions: isolation-container, needs-root
Architecture: !i386
Depends: bind9,
         bind9-dyndb-ldap,
         slapd,
         ldap-utils,
         dpkg-dev

## bind9 9.18.28

=== debian/changelog ===
bind9 (1:9.18.28-1~deb12u2A~5.2.0.202407301537) ucs5-2-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    0001-Bug-22478-build-bind-with-libdb4.8.patch
    0002-Bug-51417-Do-not-fail-on-service-start.patch
    0004-Bug-41714-Add-LDAP-support.patch
    0004-Bug-41714-Add-LDAP-support.quilt
    0017-Bug-51786-fix-apparmor-profile.patch

 -- Univention builddaemon <buildd@univention.de>  Tue, 30 Jul 2024 15:37:43 -0000

bind9 (1:9.18.28-1~deb12u2) bookworm-security; urgency=medium

  * Fix the assertion failure in samba-libs DLZ module. (Closes #1074378)

 -- Ondřej Surý <ondrej@debian.org>  Sat, 27 Jul 2024 05:13:42 +0200

bind9 (1:9.18.28-1~deb12u1) bookworm-security; urgency=high

  * New upstream version 9.18.28
   - CVE-2024-0760: A flood of DNS messages over TCP may make the server
     unstable
   - CVE-2024-1737: BIND's database will be slow if a very large number of
     RRs exist at the same name
   - CVE-2024-1975: SIG(0) can be used to exhaust CPU resources
   - CVE-2024-4076: Assertion failure when serving both stale cache data
     and authoritative zone content

 -- Ondřej Surý <ondrej@debian.org>  Tue, 16 Jul 2024 17:22:50 +0200

bind9 (1:9.18.24-1) bookworm-security; urgency=high

  * New upstream version 9.18.24
   - CVE-2023-4408: Parsing large DNS messages may cause excessive CPU
     load
   - CVE-2023-5517: Querying RFC 1918 reverse zones may cause an assertion
     failure when "nxdomain-redirect" is enabled
   - CVE-2023-5679: Enabling both DNS64 and serve-stale may cause an
     assertion failure during recursive resolution
   - CVE-2023-6516: Specific recursive query patterns may lead to an
     out-of-memory condition
   - CVE-2023-50387: KeyTrap - Extreme CPU consumption in DNSSEC validator
   - CVE-2023-50868: Preparing an NSEC3 closest encloser proof can exhaust
     CPU resources

 -- Ondřej Surý <ondrej@debian.org>  Mon, 12 Feb 2024 17:28:03 +0100

## bind9 9.18.30

=== doc/arm/requirements.txt ===
Sphinx==7.3.6
docutils==0.20.1
sphinx_rtd_theme==2.0.0

=== contrib/dlz/modules/bdbhpt/Makefile ===
# Copyright Internet Systems Consortium, Inc. ("ISC")
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, you can obtain one at https://mozilla.org/MPL/2.0/.

# Copyright (C) Stichting NLnet, Netherlands, stichting@nlnet.nl.
#
# The development of Dynamically Loadable Zones (DLZ) for Bind 9 was
# conceived and contributed by Rob Butler.
#
# SPDX-License-Identifier: ISC and MPL-2.0
#
# Permission to use, copy, modify, and distribute this software for any purpose
# with or without fee is hereby granted, provided that the above copyright
# notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND STICHTING NLNET DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL STICHTING NLNET BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

prefix = /usr
libdir = $(prefix)/lib/bind9

CFLAGS += -fPIC -g -I../include
BDB_LIBS=-ldb

all: dlz_bdbhpt_dynamic.so

dlz_bdbhpt_dynamic.so: dlz_bdbhpt_dynamic.c
	$(CC) $(CFLAGS) -shared -o dlz_bdbhpt_dynamic.so \
		dlz_bdbhpt_dynamic.c $(BDB_LIBS)

clean:
	rm -f dlz_bdbhpt_dynamic.so

install: dlz_bdbhpt_dynamic.so
	mkdir -p $(DESTDIR)$(libdir)
	install dlz_bdbhpt_dynamic.so $(DESTDIR)$(libdir)

=== contrib/dlz/modules/filesystem/Makefile ===
# Copyright Internet Systems Consortium, Inc. ("ISC")
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, you can obtain one at https://mozilla.org/MPL/2.0/.

# Copyright (C) Stichting NLnet, Netherlands, stichting@nlnet.nl.
#
# The development of Dynamically Loadable Zones (DLZ) for Bind 9 was
# conceived and contributed by Rob Butler.
#
# SPDX-License-Identifier: ISC and MPL-2.0
#
# Permission to use, copy, modify, and distribute this software for any purpose
# with or without fee is hereby granted, provided that the above copyright
# notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND STICHTING NLNET DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL STICHTING NLNET BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

prefix = /usr
libdir = $(prefix)/lib/bind9

CFLAGS += -fPIC -g -I../include

all: dlz_filesystem_dynamic.so

dir.o: dir.c
	$(CC) $(CFLAGS) -c dir.c

dlz_filesystem_dynamic.so: dlz_filesystem_dynamic.c dir.o
	$(CC) $(CFLAGS) -shared -o dlz_filesystem_dynamic.so \
		dlz_filesystem_dynamic.c dir.o

clean:
	rm -f dlz_filesystem_dynamic.so *.o

install: dlz_filesystem_dynamic.so
	mkdir -p $(DESTDIR)$(libdir)
	install dlz_filesystem_dynamic.so $(DESTDIR)$(libdir)

=== contrib/dlz/modules/mysqldyn/Makefile ===
# Copyright Internet Systems Consortium, Inc. ("ISC")
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, you can obtain one at https://mozilla.org/MPL/2.0/.

# Copyright (C) Stichting NLnet, Netherlands, stichting@nlnet.nl.
#
# The development of Dynamically Loadable Zones (DLZ) for Bind 9 was
# conceived and contributed by Rob Butler.
#
# SPDX-License-Identifier: ISC and MPL-2.0
#
# Permission to use, copy, modify, and distribute this software for any purpose
# with or without fee is hereby granted, provided that the above copyright
# notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND STICHTING NLNET DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL STICHTING NLNET BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
# OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
# CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

prefix = /usr
libdir = $(prefix)/lib/bind9

CFLAGS += -fPIC -g -I../include $(shell mysql_config --cflags)
MYSQL_LIBS=$(shell mysql_config --libs)

all: dlz_mysqldyn_mod.so

dlz_dbi.o: ../common/dlz_dbi.c
	$(CC) $(CFLAGS) -c ../common/dlz_dbi.c

dlz_mysqldyn_mod.so: dlz_mysqldyn_mod.c dlz_dbi.o
	$(CC) $(CFLAGS) -shared -o dlz_mysqldyn_mod.so \
		dlz_mysqldyn_mod.c dlz_dbi.o $(MYSQL_LIBS)

clean:
	rm -f dlz_mysqldyn_mod.so *.o

install: dlz_mysqldyn_mod.so
	mkdir -p $(DESTDIR)$(libdir)
	install dlz_mysqldyn_mod.so $(DESTDIR)$(libdir)

=== debian/changelog ===
bind9 (1:9.18.30-0ubuntu0.20.04.2) focal-security; urgency=medium

  * SECURITY UPDATE: Many records in the additional section cause CPU
    exhaustion
    - debian/patches/CVE-2024-11187.patch: limit the additional processing
      for large RDATA sets in bin/tests/*, lib/dns/include/dns/rdataset.h,
      lib/dns/rbtdb.c, lib/dns/rdataset.c, lib/dns/resolver.c,
      lib/ns/query.c.
    - CVE-2024-11187
  * SECURITY UPDATE: DNS-over-HTTPS implementation suffers from multiple
    issues under heavy query load
    - debian/patches/CVE-2024-12705.patch: fix flooding issues in
      lib/isc/netmgr/http.c, lib/isc/netmgr/netmgr-int.h,
      lib/isc/netmgr/netmgr.c, lib/isc/netmgr/tcp.c,
      lib/isc/netmgr/tlsstream.c. 
    - CVE-2024-12705

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 28 Jan 2025 09:31:22 -0500

bind9 (1:9.18.30-0ubuntu0.20.04.1) focal; urgency=medium

  * New upstream release 9.18.30 (LP: #2073310)
    - Features:
      + Print initial working directory during named startup, and changed
        working directory when loading or reloading the configuration file
      + Add max-query-restarts configuration statement
    - Updates:
      + Restrain named to specified number of cores when running via taskset,
        cpuset, or numactl
      + Reduce default max-recursion-queries value from 100 to 32
      + Raise the log level of priming failures
    - Bug Fixes:
      + Fix privacy verification of EDDSA keys
      + Fix algorithm rollover bug when there are two keys with the same keytag
      + Return SERVFAIL for a too long CNAME chain
      + Reconfigure catz member zones during named reconfiguration
      + Update key lifetime and metadata after dnssec-policy reconfiguration
      + Fix generation of 6to4-self name expansion from IPv4 address
      + Fix invalid dig +yaml output
      + Reject zero-length ALPN during SVBC ALPN text parsing
      + Fix false QNAME minimisation error being reported
      + Fix dig +timeout argument when using +http
    - See https://bind9.readthedocs.io/en/v9.18.30/notes.html for additional
      information. 

 -- Lena Voytek <lena.voytek@canonical.com>  Mon, 23 Sep 2024 17:21:48 -0400

bind9 (1:9.18.28-0ubuntu0.20.04.1) focal-security; urgency=medium

  * Updated to 9.18.28 to fix multiple security issues.
    - Please see the following for a list of changes, including possibly
      incompatible ones:
      https://kb.isc.org/docs/changes-to-be-aware-of-when-moving-from-bind-916-to-918
    - CVE-2024-0760: A flood of DNS messages over TCP may make the server
      unstable
    - CVE-2024-1737: BIND's database will be slow if a very large number of
      RRs exist at the same name
    - CVE-2024-1975: SIG(0) can be used to exhaust CPU resources
    - CVE-2024-4076: Assertion failure when serving both stale cache data
      and authoritative zone content
  * Packaging changes required for 9.18.28:
    - Dropped patches no longer required with 9.18.28:
      + 0001-Add_--install-layout=deb_to_setup.py_call.patch
      + 0002-python-fix-for-dist-packages.patch
      + 0003-Remove-the-reference-to-OPTIONS.md-it-breaks-build-o.patch
    - Synced patch with jammy's 1:9.18.28-0ubuntu0.22.04.1 package:
      + always-use-standard-library-stdatomic.patch
    - debian/NEWS: list changes in 9.18, taken from jammy.
    - debian/*: sync most of the packaging with jammy's package, including
      autopkgtests except for dyndb-ldap as the bind-dyndb-ldap package is
      broken in focal.
    - debian/tests/simpletest: wait a couple of seconds for the service to
      actually start.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 16 Jul 2024 14:48:12 -0400

bind9 (1:9.16.48-0ubuntu0.20.04.1) focal-security; urgency=medium

  * Updated to 9.16.48 to fix multiple security issues.
    - Please see the following for a list of changes, including possibly
      incompatible ones:
      https://downloads.isc.org/isc/bind9/9.16.48/doc/arm/html/notes.html
    - CVE-2023-4408
    - CVE-2023-5517
    - CVE-2023-6516
    - CVE-2023-50387
    - CVE-2023-50868
  * Packaging changes required for 9.16.48:
    - Dropped patches no longer required with 9.16.48:
      + CVE-*.patch
      + fix-rebinding-protection.patch, 
      + 0003-Print-diagnostics-on-dns_name_issubdomain-failure-in.patch
      + lp-1909950-fix-race-between-deactivating-handle-async-callback.patch
      + lp1997375-segfault-isc-nm-tcp-send.patch
    - Synced other patches with Debian's 1:9.16.48-1 package
    - debian/*.install, debian/*.links: updated with new files in 9.16.48.
    - debian/rules, debian/not-installed: don't delete old -dev files, just
      don't install them.
    - debian/control, debian/rules: switch packages required to build
      documentation.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 14 Feb 2024 07:49:14 -0500

bind9 (1:9.16.1-0ubuntu2.16) focal-security; urgency=medium

  * SECURITY UPDATE: DoS via recusive packet parsing
    - debian/patches/CVE-2023-3341.patch: add a max depth check to
      lib/isccc/include/isccc/result.h, lib/isccc/result.c, lib/isccc/cc.c.
    - CVE-2023-3341

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 19 Sep 2023 07:22:19 -0400

bind9 (1:9.16.1-0ubuntu2.15) focal-security; urgency=medium

  * SECURITY UPDATE: Configured cache size limit can be significantly
    exceeded
    - debian/patches/CVE-2023-2828.patch: fix cache expiry in
      lib/dns/rbtdb.c.
    - CVE-2023-2828

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 20 Jun 2023 08:38:29 -0400

bind9 (1:9.16.1-0ubuntu2.14) focal; urgency=medium

  * d/bind9.named.service: restart the named service on failure.
    (LP: #2006054)

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Fri, 03 Mar 2023 12:37:25 -0300

bind9 (1:9.16.1-0ubuntu2.13) focal; urgency=medium

  * d/p/lp1997375-segfault-isc-nm-tcp-send.patch: Fix segfault on
    isc__nm_tcpdns_send by moving the tcpdns processing to another
    thread. (LP: #1997375)



=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
                dh-apparmor,
                dh-apport,
                dh-exec,
+               dh-python,
                libcap2-dev [linux-any],
                libcmocka-dev,
                libdb-dev,
@@ -17,29 +18,31 @@
                libidn2-dev,
                libjson-c-dev,
                libkrb5-dev,
+               libldap2-dev,
                liblmdb-dev,
-               libltdl-dev,
+               libedit-dev,
                libmaxminddb-dev (>= 1.3.0),
                libnghttp2-dev,
                libssl-dev,
-               libsystemd-dev [linux-any],
                libtool,
-               libuv1-dev (>= 1.40.0),
+               libtool-bin,
+               libuv1-dev,
                libxml2-dev,
                pkg-config,
                python3,
+               python3-ply,
                zlib1g-dev
 Build-Depends-Indep: fonts-freefont-otf,
                      latexmk,
                      python3-sphinx,
                      python3-sphinx-rtd-theme,
-                     texlive-fonts-extra,
+                     texlive-fonts-recommended,
                      texlive-latex-recommended,
                      texlive-xetex,
                      xindy
-Standards-Version: 4.6.2
+Standards-Version: 4.1.2
 Vcs-Browser: https://salsa.debian.org/dns-team/bind9
-Vcs-Git: https://salsa.debian.org/dns-team/bind9.git -b debian/9.18
+Vcs-Git: https://salsa.debian.org/dns-team/bind9.git
 Homepage: https://www.isc.org/downloads/bind/
 
 Package: bind9
@@ -50,6 +53,7 @@
          bind9-utils (= ${binary:Version}),
          debconf | debconf-2.0,
          dns-root-data,
+         lsb-base (>= 3.2-14),
          iproute2,
          netbase,
          ${misc:Depends},
@@ -69,8 +73,7 @@
 
 Package: bind9utils
 Architecture: all
-Depends: bind9-utils,
-         ${misc:Depends}
+Depends: bind9-utils, ${misc:Depends}
 Priority: optional
 Section: oldlibs
 Description: Transitional package for bind9-utils
@@ -78,12 +81,11 @@
 
 Package: bind9-utils
 Architecture: any
-Depends: bind9-libs (= ${binary:Version}),
-         ${misc:Depends},
+Depends: ${misc:Depends},
+         ${python3:Depends},
          ${shlibs:Depends}
 Breaks: bind-utils (<< 1:9.13.6~),
-        bind9utils (<< 1:9.12.0~),
-        freeipa
+        bind9utils (<< 1:9.12.0~)
 Replaces: bind-utils (<< 1:9.13.6~),
           bind9utils (<< 1:9.12.0~)
 Provides: bind9utils
@@ -104,8 +106,7 @@
 Package: bind9-host
 Priority: standard
 Architecture: any
-Depends: bind9-libs (= ${binary:Version}),
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${shlibs:Depends}
 Provides: host
 Breaks: bind-host (<< 1:9.13.6~)
@@ -119,8 +120,7 @@
 Priority: standard
 Architecture: any
 Multi-Arch: same
-Depends: libuv1 (>= 1.40.0),
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${shlibs:Depends}
 Breaks: bind-libs (<< 1:9.13.6~)
 Replaces: bind-libs (<< 1:9.13.6~)
@@ -131,31 +131,9 @@
  .
  This package contains a bundle of shared libraries used by BIND 9.
 
-Package: bind9-dev
-Section: devel
-Priority: optional
-Architecture: any
-Multi-Arch: same
-Depends: bind9-libs (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
-Breaks: libbind-dev (<< 1:9.16.0~)
-Replaces: libbind-dev (<< 1:9.16.0~)
-Description: Static Libraries and Headers used by BIND 9
- The Berkeley Internet Name Domain (BIND 9) implements an Internet domain
- name server.  BIND 9 is the most widely-used name server software on the
- Internet, and is supported by the Internet Software Consortium, www.isc.org.
- .
- This package contains a bundle of static libraries and header files used by
- BIND 9.
- .
- Please be aware that the BIND 9 libraries are considered private by upstream
- developers and the API and ABI might break at any time.
-
 Package: dnsutils
 Architecture: all
-Depends: bind9-dnsutils,
-         ${misc:Depends}
+Depends: bind9-dnsutils, ${misc:Depends}
 Priority: optional
 Section: oldlibs
 Description: Transitional package for bind9-dnsutils
@@ -164,6 +142,7 @@
 Package: bind9-dnsutils
 Priority: standard
 Architecture: any
+Multi-Arch: foreign
 Depends: bind9-host | host,
          bind9-libs (= ${binary:Version}),
          ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing -fno-delete-null-pointer-checks -DNO_VERSION_DATE -DDIG_SIGCHASE

export DPKG_GENSYMBOLS_CHECK_LEVEL := 4

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

export arch = $(DEB_HOST_ARCH)

ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
EXTRA_FEATURES=--disable-linux-caps
endif

DEB_VERSION_REVISION := $(call dpkg_late_eval,DEB_VERSION_REVISION,echo '$(DEB_VERSION_UPSTREAM_REVISION)' | sed -e 's/^[^-]*//')

SED_VERSION_EXTENSIONS := \
	sed -e 's/\[bind_VERSION_EXTRA\], .*)/[bind_VERSION_EXTRA], $(DEB_VERSION_REVISION)-$(DEB_VENDOR))/'

EXCLUDE_FILES :=			\
	--exclude=.la			\
	--exclude=lwresd		\
	--exclude=__pycache_		\
	--exclude=sample.so		\
	--exclude=dlzexternal.so	\
	--exclude=test-async.so		\
	--exclude=libbind9.la		\
	--exclude=libdns.la		\
	--exclude=libirs.la		\
	--exclude=libisccc.la		\
	--exclude=libisccfg.la		\
	--exclude=libisc.la		\
	--exclude=libns.la

%:
	dh $@ --with python3,apport

prepare_version_extensions:
	if [ ! -f configure.ac.bak ]; then \
	  mv configure.ac configure.ac.bak; \
	  $(SED_VERSION_EXTENSIONS) < configure.ac.bak > configure.ac; \
	fi

clean_version_extensions:
	if [ -f configure.ac.bak ]; then \
	  mv configure.ac.bak configure.ac; \
	fi

override_dh_autoreconf: prepare_version_extensions
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--sysconfdir=/etc/bind \
		--with-python=python3 \
		--localstatedir=/ \
		--enable-threads \
		--enable-largefile \
		--with-libtool \
		--enable-shared \
		--disable-static \
		--with-gost=no \
		--with-openssl=/usr \
		--with-gssapi=yes \
		--with-libidn2 \
		--with-json-c \
		--with-lmdb=/usr \
		--with-gnu-ld \
		--with-maxminddb \
		--with-atf=no \
		--enable-ipv6 \
		--enable-rrl \
		--enable-filter-aaaa \
		--disable-native-pkcs11 \
		$(EXTRA_FEATURES)

override_dh_auto_build:
	sed -i 's/:gl:`\([#!][^`]*\)`/[GL \1]/g' doc/notes/*.rst
	dh_auto_build -- all html

override_dh_auto_clean: clean_version_extensions
	sed -i 's/\[GL \([#!][^]]*\)]/:gl:`\1`/g' doc/notes/*.rst
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp -- install install-html

override_dh_auto_test:
	:

override_dh_installinit:
	dh_installinit -pbind9 --name=named
	dh_installinit --remaining

override_dh_installsystemd:
	dh_installsystemd -pbind9 --no-enable --name=named-resolvconf named-resolvconf.service
	dh_installsystemd -pbind9 --name=named named.service
	dh_installsystemd --remaining

override_dh_install:
	dh_install $(EXCLUDE_FILES)
	# Install apparmor profile
	dh_apparmor -pbind9 --profile-name=usr.sbin.named

override_dh_missing:
	dh_missing $(EXCLUDE_FILES)  --fail-missing

.PHONY: prepare_version_extensions clean_version_extensions

=== debian/tests/control ===
--- 
+++ 
@@ -14,11 +14,3 @@
          bind9-dnsutils,
          bind9-utils
 
-Tests: dyndb-ldap
-Restrictions: isolation-container, needs-root
-Architecture: !i386
-Depends: bind9,
-         bind9-dyndb-ldap,
-         slapd,
-         ldap-utils,
-         dpkg-dev

## bind9 9.18.33

=== debian/changelog ===
bind9 (1:9.18.33-1~deb12u2A~5.2.0.202501301650) ucs5-2-0-0; urgency=low

  * UCS auto build. The following patches have been applied to the original source package
    0001-Bug-22478-build-bind-with-libdb4.8.patch
    0002-Bug-51417-Do-not-fail-on-service-start.patch
    0004-Bug-41714-Add-LDAP-support.patch
    0004-Bug-41714-Add-LDAP-support.quilt
    0017-Bug-51786-fix-apparmor-profile.patch

 -- Univention builddaemon <buildd@univention.de>  Thu, 30 Jan 2025 16:51:04 -0000

bind9 (1:9.18.33-1~deb12u2) bookworm-security; urgency=high

  * New upstream version 9.18.33
   - CVE-2024-12705: DNS-over-HTTPS flooding fixes
   - CVE-2024-11187: Limit additional section processing for large RDATA
     sets

 -- Ondřej Surý <ondrej@debian.org>  Sat, 25 Jan 2025 11:14:58 +0100
